# https://stackoverflow.com/questions/75430780/emulating-python-msvcrt-modules-kbhit-on-unix

import os, sys, fcntl, termios, struct, tty

def getch():
    fd = sys.stdin.fileno()
    # fetch stdin's old flags
    old_flags = fcntl.fcntl(fd, fcntl.F_GETFL)
    # set the none-blocking flag 
    fcntl.fcntl(fd, fcntl.F_SETFL, old_flags | os.O_NONBLOCK)
    try:
        ch = sys.stdin.read(1)
    except:
        ch = None
    finally:
        # resetting stdin to default falgs
        fcntl.fcntl(fd, fcntl.F_SETFL, old_flags)
    return ch 

def kbhit(): 
   return bool(fcntl.ioctl(sys.stdin.fileno(), termios.FIONREAD, struct.pack('I', 0)))

# https://gist.github.com/jasonrdsouza/1901709
def getchar():
    fd = sys.stdin.fileno()
    old_settings = termios.tcgetattr(fd)
    tty.setraw(sys.stdin.fileno())
    ch = sys.stdin.read(1)
    termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
    # Exit on ctrl-c, ctrl-d, ctrl-z, or ESC
    if ord(ch) in [3, 4, 26, 27]:
        sys.exit()
    return ch

def getchar2():
    fd = sys.stdin.fileno()
    old_settings = termios.tcgetattr(fd)
    tty.setraw(sys.stdin.fileno())
    ch = sys.stdin.read(1)
    termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
    # Exit on ctrl-c, ctrl-d, ctrl-z, or ESC
    if ord(ch) in [3, 4, 26, 27]:
        return False,' '
        sys.exit()
    return True,ch

if __name__ == "__main__":
    while True:
        if kbhit(): # returns True if the user has pressed a key
            # car = getch() # Li cal salt de línia
            car = getchar() # No li cal salt de línia
            if len(car):
                key = ord(car)
                print("Tecla premuda: %s (dec: %d, hex: 0x%2X)"%(chr(key),key,key))
        